# coding: utf-8

"""
    Security Returns

    Retrieve daily time-series of security level returns  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.security_analytics.returns.v1.SecurityReturnsAPI.models.v1_daily_return import V1DailyReturn

class V1DailyReturnSeries(BaseModel):
    """
    V1DailyReturnSeries
    """
    asset_id: Optional[StrictStr] = Field(None, alias="assetId")
    price_hierarchy: Optional[StrictStr] = Field(None, alias="priceHierarchy")
    daily_returns: Optional[conlist(V1DailyReturn)] = Field(None, alias="dailyReturns")
    __properties = ["assetId", "priceHierarchy", "dailyReturns"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1DailyReturnSeries:
        """Create an instance of V1DailyReturnSeries from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in daily_returns (list)
        _items = []
        if self.daily_returns:
            for _item in self.daily_returns:
                if _item:
                    _items.append(_item.to_dict())
            _dict['dailyReturns'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1DailyReturnSeries:
        """Create an instance of V1DailyReturnSeries from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1DailyReturnSeries.parse_obj(obj)

        _obj = V1DailyReturnSeries.parse_obj({
            "asset_id": obj.get("assetId"),
            "price_hierarchy": obj.get("priceHierarchy"),
            "daily_returns": [V1DailyReturn.from_dict(_item) for _item in obj.get("dailyReturns")] if obj.get("dailyReturns") is not None else None
        })
        return _obj

