# coding: utf-8

"""
    Security Returns

    Retrieve daily time-series of security level returns  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.security_analytics.returns.v1.SecurityReturnsAPI.models.v1_daily_return_series import V1DailyReturnSeries

class V1RetrieveDailyReturnsResponse(BaseModel):
    """
    RetrieveDailyReturnsResponse describes ...
    """
    daily_return_series: Optional[conlist(V1DailyReturnSeries)] = Field(None, alias="dailyReturnSeries")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted, there are no subsequent pages.")
    __properties = ["dailyReturnSeries", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1RetrieveDailyReturnsResponse:
        """Create an instance of V1RetrieveDailyReturnsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in daily_return_series (list)
        _items = []
        if self.daily_return_series:
            for _item in self.daily_return_series:
                if _item:
                    _items.append(_item.to_dict())
            _dict['dailyReturnSeries'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1RetrieveDailyReturnsResponse:
        """Create an instance of V1RetrieveDailyReturnsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1RetrieveDailyReturnsResponse.parse_obj(obj)

        _obj = V1RetrieveDailyReturnsResponse.parse_obj({
            "daily_return_series": [V1DailyReturnSeries.from_dict(_item) for _item in obj.get("dailyReturnSeries")] if obj.get("dailyReturnSeries") is not None else None,
            "next_page_token": obj.get("nextPageToken")
        })
        return _obj

